package strutsguide.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import strutsguide.beans.LogInProcess;
import strutsguide.beans.UserInfoBean;
import strutsguide.forms.Login2Form;

/**
 * Login2  α Ѵ.
 */
public class Login2Action extends Action {

    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {

        LogInProcess logInProcess = LogInProcess.getInstance();

        // ̹ ⺻ Ķ   ActionForm ü ´.
        Login2Form login2Form = (Login2Form) form;

        // ڰ  Ķ͸ Ѵ.
        String userName = login2Form.getUsername();
        String password = login2Form.getPassword();

        UserInfoBean userInfo = logInProcess.logIn(userName, password);

        ActionForward forward = null;

        if (userInfo == null) {
            // userInfo null̸ ڰ  ʰų йȣ ߸ ̴.
            ActionMessages messages = new ActionMessages();

            // ۷ι ޽ ߰Ѵ.
            // ̰ <html:messages id="msg" message="true">  JSP µȴ.
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
                    "error.invalidLogin"));

            // request ü ޽ ߰
            saveMessages(request, messages);

            //  Էȭ ư Ѵ.
            // <action input="" />  input   ǹѴ.
            return mapping.getInputForward();

        }

        // null ƴϸ   ̵Ѵ. ̵ϱ    session Ѵ.
        HttpSession session = request.getSession();
        session.setAttribute("userInfo", userInfo);

        // ̵  ã´.
        // <forward name="login2Form" /> ãƼ Ѵ.
        forward = mapping.findForward("login2Form");

        return forward;
    }
}
