package strutsguide.exhandlers;

import java.util.Date;

import org.apache.struts.action.*;
import org.apache.struts.config.ExceptionConfig;

import javax.servlet.ServletException;
import javax.servlet.http.*;

import org.apache.commons.logging.*;

/**
 * Ʈ ExceptionHandler .
 * Action try/catch  ϰ ״ throw  ܵ
 * struts-config.xml &lt;exception&gt;   ̰
 * ޵ȴ.
 */
public class SGExceptionHandler extends ExceptionHandler {

    Log log = LogFactory.getLog(SGExceptionHandler.class);
    
    /**
     * Action ܰ ߻ϸ &lt;exception&gt;   Ʒ Ѵ.
     */
    public ActionForward execute(Exception ex,
            ExceptionConfig config,
            ActionMapping mapping,
            ActionForm form,
            HttpServletRequest request,
            HttpServletResponse response) throws ServletException {
        
        // ߻ ܽð ؼ ο ڿ Ѵ.
        String [] args = new String[2];

        long currentTimeMillis = System.currentTimeMillis();
        Date currentTime = new Date(currentTimeMillis);
        
        //  ð ڷ .
        args[0] = currentTime.toString();
        //  ޽ ڷ .
        args[1] = ex.getMessage();
        
        //  Ű ޽ ޽ ҽ 鿡  {0}, {1} 
        // ڷ üϿ ο ޽ .
        ActionMessage errorMessage = new ActionMessage(config.getKey(), args);
        
        //   ǥ  Ʈ Ѵ.
        System.err.println(errorMessage.toString());
        ex.printStackTrace();
        
        
        //     JSP ã´. <exception path=""/>  
        ActionForward forward = new ActionForward(config.getPath());
        
        //  ׵ request Ѵ.
        storeException(request, config.getKey(), errorMessage, forward, config.getScope());

        // ~!
        return forward;
    }
}
