package strutsguide.forms;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

/**
 * Login2Action  Action Form
 *
 */
public class Login2Form extends ActionForm {

    /** ڸ */
    private String username = null;
    
    /** йȣ */
    private String password = null;
    
    /**
     * ڸ ϱ
     * @param username ڸ
     */
    public void setUsername(String username) {
        this.username = username;
    }
    
    /**
     * ڸ ϱ
     * return ڸ
     */
    public String getUsername() {
        return username;
    }
    
    /**
     * йȣ ϱ
     * @param password йȣ
     */
    public void setPassword(String password) {
        this.password = password;
    }
    
    /**
     * йȣ ϱ
     */
    public String getPassword() {
        return password;
    }
    
    /**
     * ڸ йȣ ùٸ Էߴ θ ˻Ѵ.
     * 
     * validate() ȣǱ  ̹ setUsername() setPassword() ȣǾ
     * username password     ̴.
     * 
     * @param mapping ׼  ü
     * @param request HTTP Request ü
     * @return  
     */
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        ActionErrors errors = new ActionErrors();
        
        // ڸ Է ʾҰų  ϰ  
        if (username == null || username.length() == 0) {
            errors.add("invalidUsernameError",
                    new ActionMessage("error.invalidUsername", "ڸ Էּ."));
        } else if (username.indexOf(" ") >= 0 || username.indexOf("\t") >= 0 ||
                username.indexOf("\n") >= 0) {
            errors.add("invalidUsernameError",
                    new ActionMessage("error.invalidUsername", "ڸ    ϴ."));
        }
        
        // йȣ Է ʾ 
        if (password == null || password.length() == 0) {
            errors.add("invalidPasswordError",
                    new ActionMessage("error.invalidPassword"));
        }
        
        /*
         * ActionErrors errors ü null̰ų ƹ ActionMessage ü ϰ  
         *  ߻ ʾҴٰ Ѵ.
         */
        return errors;
    }
}
